package hdm.mi.growbros.controllers;


import hdm.mi.growbros.models.GardenEntry;
import hdm.mi.growbros.models.plant.Plant;
import hdm.mi.growbros.models.user.User;
import hdm.mi.growbros.service.GrandmaService;
import org.springframework.http.ResponseEntity;
import org.springframework.security.core.annotation.AuthenticationPrincipal;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/api/v1/Grandma")
public class GrandmaController {

    private final GrandmaService grandmaService;

    public GrandmaController(GrandmaService grandmaService){
        this.grandmaService = grandmaService;
    }

    @GetMapping ("/getGrowingTips")
    public ResponseEntity<String> getGrowingTipDesTages(@AuthenticationPrincipal User user) {
        return ResponseEntity.ok(grandmaService.growingTippDesTages(user));
    }
    @GetMapping ("/getGrowablePlants")
    public ResponseEntity<List<Plant>> getPlantsReadyToGrow(@AuthenticationPrincipal User user){
            return ResponseEntity.ok(grandmaService.getPlantsReadyToGrow(user));

    }
    @GetMapping ("/getPlantsNeedingWatering")
    public ResponseEntity<List<GardenEntry>> getPlantsNeedingWatring (@AuthenticationPrincipal User user){
        return ResponseEntity.ok(grandmaService.getGardenEntriesNeedingWatering(user));
    }
    @PostMapping("/setNewWateringFrequency")
    public void setNewWateringService(@RequestParam("wateringFrequency") int wateringFrequency , @RequestBody GardenEntry gardenEntry){
        gardenEntry.setWateringFrequency(wateringFrequency);
    }
    @GetMapping("/getPlantsReadyToHarvest")
    public ResponseEntity<List<GardenEntry>> getPlantsReadyToHarvest(@AuthenticationPrincipal User user){
        List<GardenEntry> plantsReadyToHarvest = grandmaService.getPlantsReadyToHarvest(user);
        return ResponseEntity.ok(plantsReadyToHarvest);
    }
}
